module icanvas;

import tk.geometry;

interface ICanvas {
    void rel_zoom(Point screen_datum, double factor);
    void rel_pan(Vector screen_displacement);
    //void damage();
}

import tk.events;

interface ICanvasEventHandler {
    bool handle_button_press(ICanvas canvas, in ButtonEvent event);
    bool handle_button_release(ICanvas canvas, in ButtonEvent event);
    bool handle_key_press(ICanvas canvas, in KeyEvent event);
    bool handle_key_release(ICanvas canvas, in KeyEvent event);
    bool handle_motion(ICanvas canvas, in MotionEvent event);
    bool handle_scroll(ICanvas canvas, in ScrollEvent event);
    //bool handle_expose(ICanvas canvas, ExposeEvent event);
    //bool handle_enter(ICanvas, CrossingEvent event);
    //bool handle_leave(ICanvas, CrossingEvent event);
    //bool handle_focus_in(ICanvas, FocusEvent event);
    //bool handle_focus_out(ICanvas, FocusEvent event);
}
